## This function file runs every tick, nothing in here should be modified unless intentionally modifying the datapack ##

# Enable the actionbar and max timer for all players every tick
execute as @a at @s run scoreboard players enable @s disable_tnt_actionbar
execute as @a at @s run scoreboard players enable @s tnt_spawn_speed

# If the max is set to 0, set it back to the default
execute as @a at @s if score @s tnt_spawn_speed matches 0 run tellraw @s ["",{"text":"Setting TNT Timer to the default: ","color":"white"},{"score":{"name":"tnt_fake_player","objective":"tnt_timer_default"},"bold":true,"color":"red"}]
execute as @a at @s if score @s tnt_spawn_speed matches 0 run scoreboard players operation @s tnt_spawn_speed = tnt_fake_player tnt_timer_default

# Every tick, add one to the timer
execute as @a at @s run scoreboard players add @s tnt_timer 1

# If the timer is greater than 20, add one to the seconds timer
execute as @a at @s if score @s tnt_timer matches 20.. run scoreboard players add @s tnt_timer_seconds 1

# If the timer is greater than 20, reset the original tnt timer
execute as @a at @s if score @s tnt_timer matches 20.. run scoreboard players reset @s tnt_timer

# Action bar. Only runs if the tnt_timer_seconds scoreboard is set to any real number or if the actionbar is enabled
# also is disabled if the player is in any other gamemode other than survival. Might change this but this works for now.
execute as @a[gamemode=survival] at @s unless score @s tnt_start matches 0 if score @s tnt_timer_seconds matches -2147483648..2147483647 if score @s disable_tnt_actionbar matches 0 run title @s actionbar ["",{"text":"TNT will spawn in ","bold":true,"color":"red"},{"score":{"name":"@s","objective":"tnt_timer_subtracted"},"bold":true,"color":"gold"},{"text":" seconds","bold":true,"color":"red"}]

# Summons the tnt if the player is in survival, and if tnt_start is not 0 and if the seconds on the timer 
# in seconds is greater or equal to the timer max
execute as @a[gamemode=survival] at @s unless score @s tnt_start matches 0 if score @s tnt_timer_seconds >= @s tnt_spawn_speed run summon minecraft:tnt ~ ~ ~ {Fuse:60}

# Sends chat message once tnt is spawned to tell the chat that tnt has been spawned on that player
execute as @a[gamemode=survival] at @s unless score @s tnt_start matches 1 if score @s tnt_timer_seconds >= @s tnt_spawn_speed run tellraw @a ["",{"text":"Summoned ","color":"green"},{"text":"TNT","bold":true,"color":"red"},{"text":" on ","color":"green"},{"selector":"@s","bold":true,"color":"red"}]

# Reset the seconds timer 
execute as @a at @s if score @s tnt_timer_seconds >= @s tnt_spawn_speed run scoreboard players reset @s tnt_timer_seconds

# Make a subtracted version of the seconds timer by setting it to the max, and then subtracting it by
# the current second amount. This has to be done because two operations can't seem to be done at the
# same time by minecraft commands
execute as @a at @s run scoreboard players operation @s tnt_timer_subtracted = @s tnt_spawn_speed
execute as @a at @s run scoreboard players operation @s tnt_timer_subtracted -= @s tnt_timer_seconds